package ch.programmieraufgaben.planetensortieren.gui;

import ch.programmieraufgaben.planetensortieren.model.Sonnensystem;

/**
 * Communicate to the gui.
 * Diese Schnittstelle gibt an, wie das Modell die Daten darstellen kann.
 * Ebenso werden Methoden zur Verfügung gestellt, mit denen das Controller-GUI
 * ausgelesen werden können.
 * @author Philipp Gressly (phi@gressly.ch)
 */
/*
 * History: first Implementation: Jul 15, 2009
 * Bugs   :
 */
public interface GUI {
    
    /**
     * vertausche im "SolarPanel-Thread"
     */
    void tausche(int pos1, int pos2);

    
    /**
     * Zeige, dass im Moment pos1 mit pos2 verglichen wurde.
     * @param istKleiner deutet an, dass [pos1] bereits kleiner als [pos2] ist
     */
    void vergleich(int pos1, int pos2, boolean istKleiner);

    
    /**
     * Sortierkriterium (z. B. "name", "masse")
     */
    String getKriterium();

    
    /**
     * Sortierkriterium (z. B. "name", "masse")
     */
    void setKriterium(String kriterium);

    
    /**
     * Get the Model Class.
     */
    Sonnensystem getSonnensystem();

    
    /**
     * Sortiergeschwindigkeit
     */
    long getVitesse();

    
    /**
     * The user interrupted the graphical 
     */
    void stopSorting();

    
    /**
     * Aufsteigend oder Absteigend sortiert?
     */
    boolean isAscendig();

    
    /**
     * Neu layouten (position) und neu zeichnen.
     */
    void validateSonnensystemPanel();

}  // end of class GUI
