package ch.programmieraufgaben.planetensortieren.gui;

import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;
import java.util.ResourceBundle;

import javax.swing.*;

import ch.programmieraufgaben.planetensortieren.model.Info;

/**
 * Infos für die Planeten: Name, Masse, ... (alles, was in "Planet.java" deklariert wurde.)
 * 
 * @author Philipp Gressly (phi AT gressly DOT ch)
 */
public class InfoPanel extends JPanel {
    ArrayList<Info> infos = new ArrayList<Info>();
    GUI gui;

    public InfoPanel(GUI gui){
        this.gui = gui;
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        setForeground(Color.WHITE);
        setBackground(Color.BLACK);  }

    
    void addInfo(String key, String value) {
        infos.add(new Info(key, value));
        addLabel(key, value, false);  }

    
    ResourceBundle rb = ResourceBundle.getBundle("ch.programmieraufgaben.planetensortieren.model.model");
    
    private void addLabel(String key, String value, boolean mark) {
        JLabel jl = new JLabel(value);
        jl.setToolTipText(rb.getString(key  + ".title"));
        jl.setForeground(Color.WHITE);
        jl.setBackground(Color.BLACK);
        jl.setOpaque(true);
        if (mark) {
            Font f = jl.getFont().deriveFont(Font.BOLD);
            jl.setOpaque(true);
            jl.setForeground(Color.CYAN);
            jl.setFont(f);  }
        this.add(jl);  }

    
    /**
     * @param string
     */
    public void setSortCriteria() {
        String actKey;
        if(null != gui) {
          actKey = gui.getKriterium(); }
        else {
            actKey = "name";  } // default
        this.removeAll();
        for (Info info : infos) {
            boolean mark = info.getKey().equals(actKey);
            addLabel(info.getKey(), info.getValue(), mark);  }
    }

} // end of class InfoPanel
