package ch.programmieraufgaben.planetensortieren.gui;

import java.awt.*;
import java.net.URL;

import javax.swing.*;

/**
 * Draw an image, but scale if necessary.
 * @author Philipp Gressly (phi@gressly.ch)
 */
/*
 * History: first Implementation: Jul 16, 2009
 * Bugs   :
 */
public class ScaleableImagePanel extends JComponent {

    static ClassLoader cl           ;
    ImageIcon          imageIcon    ;
    Color              brightenColor;
    
    public ScaleableImagePanel(String imageURL){
        if(null == cl) { // singletone
            cl = this.getClass().getClassLoader();  }
        URL url = cl.getResource("ch/programmieraufgaben/planetensortieren/gui/" + imageURL);
        imageIcon = new ImageIcon(url);  }
    
    
    /**
     * Zeichne den Planeten. Falls "brightenColor" gesetzt ist,
     * wird der Planet eingefärbt.
     */
    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        int w = getWidth();
        int h = getHeight();
        int x = 0;
        int y = 0; // top left pos 
        int diam = Math.min(w, h);
        if(w < h) { // hohes bild
          y = (h - diam) / 2;  } 
        else { // breitbild
          x = (w - diam) / 2;  }
        g2.drawImage(imageIcon.getImage(), x, y, diam, diam, Color.BLACK, this); 
        if(null != brightenColor) {
            g2.setColor(brightenColor);
            g2.fillRect(0, 0, w, h);   }
    }

    
    /**
     * Setze die "brighten"-Farbe. 
     */
    public void lighten(Color c) {
       brightenColor = new Color(c.getRed(), c.getGreen(), c.getBlue(), 60);
    }
    
    public void unlighten() {
        brightenColor = null;
    }
    
}  // end of class
