package ch.programmieraufgaben.planetensortieren.gui;

import java.awt.Color;
import java.awt.Component;
import java.util.ResourceBundle;

import javax.swing.*;

/**
 * Passe die Farben der Dropdown Liste "SortBy" (Sortierkriterium) 
 * an die Farben im Info-Panel an.
 * An Stelle der Attribute stehen die lesbaren (sprachabhängigen) Texte aus
 * model.model_XX.properties.
 * @author Philipp Gressly (phi@gressly.ch)
 */
/*
 * History: first Implementation: Jul 20, 2009
 * Bugs   :
 */
public class SortByDropdownRenderer implements ListCellRenderer {

    JLabel cellRenderer = new JLabel();
    
    public SortByDropdownRenderer() {
        cellRenderer.setOpaque(true); }

    ResourceBundle rb = ResourceBundle.getBundle("ch.programmieraufgaben.planetensortieren.model.model");
    
    /*
     * @see javax.swing.ListCellRenderer#getListCellRendererComponent(javax.swing.JList, java.lang.Object, int, boolean, boolean)
     */
    @Override
    public Component getListCellRendererComponent(JList list, Object value,
            int index, boolean isSelected, boolean cellHasFocus) {
        cellRenderer.setText("" + rb.getString(value + ".title"));
        
        if(cellHasFocus) {
            cellRenderer.setBackground(Color.CYAN);  }
        else {
            cellRenderer.setBackground(Color.BLACK);  }
        if(isSelected) {
            cellRenderer.setForeground(Color.CYAN);  }
        else {
            cellRenderer.setForeground(Color.WHITE); }
        
        return cellRenderer;  }

} // end of class SortByDropdownRenderer